%global debug_package %{nil}
%global _python_bytecompile_errors_terminate_build 0
%bcond_with ts2

Summary:    Check ABI/API differences between rpm packages
Name:       rpm-check
Version:    7.6
Release:    2%{?dist}
License:    GPLv2
URL:        https://git.woa.com/tlinux/TSS-tools/ocs-rpm-check
Source0:    rpm_check-%{version}.tar.gz

BuildRequires: python3-setuptools python3-wheel python3-pip gcc
%if %{without ts2}
BuildRequires: python3-Cython3 python3-pyyaml pyproject-rpm-macros python3-devel
Requires:   python3-prettytable python3-rpm python3-chardet python3-pyyaml
Requires:   abi-compliance-checker >= 2.3-5 abi-dumper >= 1.2-4
Requires:   java japi-compliance-checker java-17-konajdk-devel
Requires:   rpmlint python-clang clang-devel python3-lxml vtable-dumper
Requires:   python3-beautifulsoup4
Recommends: rpm-dep >= 4.5
%else
BuildRequires: python3-importlib-metadata
Requires:   python3-rpm python3-importlib-metadata python3-PyYAML python3-lxml
Requires:   python3-beautifulsoup4
%endif


ExclusiveArch:  x86_64 aarch64 loongarch64

%description
This package provides a tool to check the ABI and API differences between two
given rpms.

%package tools
Summary:  rpm-check toolset
%if %{without ts2}
Requires: python3-pipdeptree
%endif
Requires: rpm-check

%description tools
This package provides tools to make reports of ABI/API and requirements based on
the entire system.

%prep
%autosetup -n rpm_check-%{version}

%build
%if %{without ts2}
python3 setup.py build_ext --inplace
%pyproject_wheel
%else
%py3_build
%endif

%install
%if %{without ts2}
%pyproject_install
%else
%py3_install
%endif

mkdir -p %{buildroot}%{_sysconfdir}/%{name}/
install -Dpm644 conf/order_list %{buildroot}%{_sysconfdir}/%{name}/
install -Dpm644 conf/special_name_list %{buildroot}%{_sysconfdir}/%{name}/
install -Dpm644 conf/rules.xml %{buildroot}%{_sysconfdir}/%{name}/
install -Dpm644 conf/rpm-check.conf %{buildroot}%{_sysconfdir}/rpm-check.conf
install -Dpm644 conf/ai_config.ini %{buildroot}%{_sysconfdir}/%{name}/
mkdir -p %{buildroot}%{python3_sitelib}/rpm_check

mkdir -p %{buildroot}%{_prefix}/libexec/%{name}
install -dm777 %{buildroot}%{_localstatedir}/%{name}/
install -Dpm644 tools/* %{buildroot}%{_prefix}/libexec/%{name}/

%files
%license LICENSE
%{_bindir}/rpm-check
%{_localstatedir}/%{name}/
%config %{_sysconfdir}/rpm-check.conf
%dir %{_sysconfdir}/%{name}
%config %{_sysconfdir}/%{name}/order_list
%config %{_sysconfdir}/%{name}/special_name_list
%config %{_sysconfdir}/%{name}/rules.xml
%config %{_sysconfdir}/%{name}/ai_config.ini
%if %{without ts2}
%{python3_sitearch}/*
%else
%{python3_sitelib}/*
%endif

%files tools
%{_prefix}/libexec/%{name}/

%changelog
* Fri Oct 11 2024 cunshunxia <cunshunxia@tencent.com> - 7.6-3
- support build and run on lower version release.

* Wed Oct 09 2024 cunshunxia <cunshunxia@tencent.com> - 7.6-2
- support loongarch64

* Tue Oct 08 2024 cunshunxia <cunshunxia@tencent.com> - 7.6-1
- support ai interpret report ability
- add logger and argparser
- support checkabi without debuginfo which means only symbols
  added/removed comparison and add testcase for it.
- fix testcase for new output format
- add --search-remote option for abicheck online.

* Thu Sep 19 2024 cunshunxia <cunshunxia@tencent.com> - 7.5-1
- add scan-dep option for searching python module used.
- support alias parse in python file
- fix crash when decode json

* Thu Sep 19 2024 cunshunxia <cunshunxia@tencent.com> - 7.4-2
- add the class itself to interface_functions with its base classes

* Thu Sep 19 2024 cunshunxia <cunshunxia@tencent.com> - 7.4-1
- upgrade to 7.4
- fix maximum recursion depth exceeded error.

* Thu Sep 12 2024 cunshunxia <cunshunxia@tencent.com> - 7.3-6
- fix jar abicheck error

* Tue Sep 10 2024 cunshunxia <cunshunxia@tencent.com> - 7.3-5
- fix confcheck error.
- make conf diff results to dict.

* Tue Sep 10 2024 cunshunxia <cunshunxia@tencent.com> - 7.3-4
- change result of filelist changed to dict.

* Mon Sep 09 2024 cunshunxia <cunshunxia@tencent.com> - 7.3-3
- fix python api will not continue when debug not found.
- add language item to python_dict.

* Mon Sep 09 2024 cunshunxia <cunshunxia@tencent.com> - 7.3-2
- rename dict 'result' to 'package', and make it child of list result.

* Fri Sep 06 2024 cunshunxia <cunshunxia@tencent.com> - 7.3-1
- upgrade to 7.3
- comprehensive optimization of the logging architecture.

* Wed Aug 21 2024 cunshunxia <cunshunxia@tencent.com> - 7.2-2
- add 'Version changed' in filelist log for CI use.
- support multi-thread in pr counting tool.

* Mon Aug 19 2024 cunshunxia <cunshunxia@tencent.com> - 7.2-1
- upgrade to 7.2
- consider soname first as report path and fix testcases
- add testcase for --check-local and --search-local
- update pr count script with AI_disagree_exec label
- support json output pr details
- fix download failed when pkg not in repo
- add check_special_name back for sha value in library name
- Decouple the different package manager sections

* Thu Aug 01 2024 cunshunxia <cunshunxia@tencent.com> - 7.1-3
- fix more than one doc in single yaml file problem.

* Wed Jul 17 2024 cunshunxia <cunshunxia@tencent.com> - 7.1-2
- fix all_doc_files returns all_files results
- If we got a/b/c/d.so and a/b/d.so in one pkg, we recognize them as different libs.
- fix logic error in determining capability compatibility for a single package
- support parsing pyproject_extras_subpkg option -i

* Mon Jul 01 2024 cunshunxia <cunshunxia@tencent.com> - 7.1-1
- upgrade to 7.1 version
- take ci process out as one separate module.
- add --pr and --token option for pull request.
- fix more than one extrapkg in pyproject_extras_subpkg

* Wed Jun 19 2024 cunshunxia <cunshunxia@tencent.com> - 7.0-2
- fix devel pkg detection multi times
- add which pkg the devel belongs to in summary.log.

* Tue Jun 18 2024 cunshunxia <cunshunxia@tencent.com> - 7.0-1
- upgrade to 7.0 version
- support --check-local, --search-local option
- support ABI check in upgrade distro scence.
- optimize python auto pkg process.

* Wed May 22 2024 cunshunxia <cunshunxia@tencent.com> - 6.15-5
- fix abnormal lib name like /usr/lib64/bash/stat causing matching problem.

* Tue May 21 2024 cunshunxia <cunshunxia@tencent.com> - 6.15-4
- fix abi-dumper output decode failed with utf-8.

* Tue May 21 2024 cunshunxia <cunshunxia@tencent.com> - 6.15-3
- fix mismatch of abnormal lib name in octave.

* Mon May 13 2024 cunshunxia <cunshunxia@tencent.com> - 6.15-2
- fix conf log wrong content if no diff in .pc file.

* Tue May 07 2024 cunshunxia <cunshunxia@tencent.com> - 6.15-1
- compile with extension modules.

* Mon Apr 15 2024 cunshunxia <cunshunxia@tencent.com> - 6.14-3
- fix wrong match with numbder in lib path.

* Thu Mar 21 2024 cunshunxia <cunshunxia@tencent.com> - 6.14-2
- fix incorrect log in summary when ABI is the same.

* Mon Mar 11 2024 cunshunxia <cunshunxia@tencent.com> - 6.14-1
- add new toolset for python dep check.

* Mon Mar 04 2024 cunshunxia <cunshunxia@tencent.com> - 6.13-2
- Bugfix release
- fix XXX_summary.log XXX_abidiff.log order problem caused by multi-thread.
- fix same name lib in one rpm making matching problem.

* Tue Feb 20 2024 cunshunxia <cunshunxia@tencent.com> - 6.13-1
- upgrade to 6.13
- Bugfix release
- put all XXX_summary.log XXX_abidiff.log into one single log
  which used by CI.
- fix problems caused by rpm-dep log name change.

* Fri Jan 26 2024 cunshunxia <cunshunxia@tencent.com> - 6.12-1
- upgrade to 6.12
- use old/new replace long path in log
- use multi-process to check single rpm
- Bugfix:
- fix Related file missed in table and backup log failed
- fix japi arguement number problem
- fix ast parse problem in 'import A.B' use A.B.C situation.
- fix safe_load may return a list which cause problem

* Fri Jan 26 2024 cunshunxia <cunshunxia@tencent.com> - 6.11-1
- upgrade to 6.11
- log the pkg which is not supported by abicheck now
- support local symbol database when searching affected rpms.
- fix confcheck crash with abnormal xml.
- fix param changed in process_file_path

* Tue Jan 23 2024 cunshunxia <cunshunxia@tencent.com> - 6.10-1
- upgrade to 6.10
- add log when no difference found
- fix conf check failed with macros.d dir
- fix download failed cause process exit, make download multi-thread
- workaround multi-thread race bug
- remove sys.exit in check_compatibility

* Mon Jan 15 2024 cunshunxia <cunshunxia@tencent.com> - 6.9-1
- upgrade to 6.9
- bugfix:
- fix broken symlink may cause 'no such file or directory'
- fix if the package downloading not exist, process may exit.
- fix no header file in devel pkg may cause 'list out of range'
- feature:
- make temp directory can be configured in rpm-check.conf
- return 0 if process exit normally
- use rpm-dep --only-others to remove sub pkg influence
- direct python compatibility check result to summary

* Mon Jan 08 2024 cunshunxia <cunshunxia@tencent.com> - 6.8-1
- upgrade to 6.8
- bugfix release
- optimize matching of version in qt5 path.
- fix problems with severity safe are counted in compatibility.
- fix if rq_rpm_list is empty, will return NoneType than empty table.
- use rpm-dep -S instead of ci-rpm-dep -S.
- make symbols in different header files together, thus listed together

* Fri Dec 29 2023 cunshunxia <cunshunxia@tencent.com> - 6.7-1
- upgrade to 6.7
- bugfix release
- if dump file has no symbol with public header, process may exit.
- fix that glib2 has more than one devel path.
- add rpm name in so not found situation
- last, see you 2023.

* Mon Dec 25 2023 cunshunxia <cunshunxia@tencent.com> - 6.6-1
- upgrade to 6.6
- filter out the unimportant path/doc in filelist check.
- add more log for different situation in ABI
- use public header when abi-dumper to filter out the private header
- fix abicheck with devel and fix verbose mode not save former dump file

* Tue Dec 19 2023 cunshunxia <cunshunxia@tencent.com> - 6.5-1
- upgrade to 6.5
- optimize the path and library matching logic.

* Fri Dec 15 2023 cunshunxia <cunshunxia@tencent.com> - 6.4-1
- upgrade to 6.4
- conf_check results direct to log
- symbols affected now consider private header and public header
- skip same file with different version in path, 
  like'/usr/lib64/erlang/lib/compiler-8.2.4/src/rec_env.erl'
- fix `can't find debug info in object` error.

* Thu Dec 07 2023 cunshunxia <cunshunxia@tencent.com> - 6.3-1
- upgrade to 6.3
- add '--multi-packages' option
- add tools for release note auto-generation
- use multi-thread for all options
- use mktempdir() instead of 'tmpa'/'tmpb'
- support iso release note auto-generation
  - modify output format of all options
  - add output file for confcheck
  - optimize log format of confcheck

* Mon Nov 27 2023 cunshunxia <cunshunxia@tencent.com> - 6.2-1
- upgrade to 6.2.
- use threadpool for C/C++ and python check

* Mon Nov 27 2023 cunshunxia <cunshunxia@tencent.com> - 6.1-1
- upgrade to 6.1.
- python api check optimize
  - parse check file into ast tree for affecting analyze.
  - python api support --verbose option.
- fix --with-symbol 'cannot access local variable 'table'' error.
- mute the rpm2cpio warning log in common.py
- fix unregular file parsed failed in ast

* Thu Nov 23 2023 cunshunxia <cunshunxia@tencent.com> - 6.0-1
- upgrade to 6.0.
- add option --with-symbol
- support checking affected pkgs by specific symbols and types.
- show affected table in summary.log
- fix bugs in abilitycheck caused by new string item.

* Mon Nov 13 2023 cunshunxia <cunshunxia@tencent.com> - 5.9-1
- upgrade to 5.9
- support symbols and constants details in abidiff.log.
- ABICC check with --strict.

* Mon Nov 13 2023 cunshunxia <cunshunxia@tencent.com> - 5.8-1
- add soname output in summary for requires search.

* Thu Nov 09 2023 cunshunxia <cunshunxia@tencent.com> - 5.7-1
- dynamic library with different version will be list as
- version changed which is only warning instead of error.

* Wed Nov 08 2023 cunshunxia <cunshunxia@tencent.com> - 5.6-1
- upgrade to 5.6
- dont show changed filelist anymore
- show rpm name at the begining of confcheck
- change the log level of debuginfo not found
- fix --version error

* Fri Nov 03 2023 cunshunxia <cunshunxia@tencent.com> - 5.5-1
- upgrade to 5.5
- minimize the result outpu
- fix results of checkfile printed many times.
- fix ability will clear all same name ability.

* Wed Nov 1 2023 cunshunxia <cunshunxia@tencent.com> - 5.4-1
- upgrade to 5.4
- fix conf_check failed with special section in xml
- fix macros files match error

* Mon Oct 30 2023 cunshunxia <cunshunxia@tencent.com> - 5.3-1
- upgrade to 5.3
- optimize the final results for CI issue.

* Fri Oct 27 2023 cunshunxia <cunshunxia@tencent.com> - 5.2-1
- upgrade to 5.2
- Bugfix:
- find assign start with "*" error
- library with same string matching
- add blank in output of rpm_name for ci process

* Tue Oct 24 2023 cunshunxia <cunshunxia@tencent.com> - 5.1-1
- upgrade to 5.1
- optimize filecheck and abilitycheck results
- support java check in normal abicheck process
- fix assign same with function

* Tue Oct 24 2023 cunshunxia <cunshunxia@tencent.com> - 5.0-1
- upgrade to 5.0
- support java jar abi/api check.

* Mon Oct 23 2023 cunshunxia <cunshunxia@tencent.com> - 4.13-1
- upgrade to 4.13
- fix python decorators problem and null list in abilitycheck

* Thu Oct 19 2023 cunshunxia <cunshunxia@tencent.com> - 4.12-1
- fix abicheck debuginfo pkg not found problem.
- make pycheck output more clear.

* Wed Oct 18 2023 cunshunxia <cunshunxia@tencent.com> - 4.11-1
- fix Library soname version changed problem caused by project 
- transform.

* Wed Oct 18 2023 cunshunxia <cunshunxia@tencent.com> - 4.10-1
- upgrade to 4.10
- switch to python project for CI
- checkfile and checkability support --dir
- support conf check, including service file, xml, json, macros,
- yaml and config path.

* Mon Oct 09 2023 cunshunxia <cunshunxia@tencent.com> - 4.9-1
- upgrade to 4.9
- support vars check
- check with more specific symbols including module names.

* Wed Sep 27 2023 cunshunxia <cunshunxia@tencent.com> - 4.8-1
- upgrade to 4.8
- search pkgs including buildrequires.

* Wed Sep 27 2023 cunshunxia <cunshunxia@tencent.com> - 4.7-1
- upgrade to 4.7
- search python methods with module.class.methods instead of
- only methods.

* Tue Sep 26 2023 cunshunxia <cunshunxia@tencent.com> - 4.6-1
- upgrade to 4.6
- support rpm-dep check python compatibility
- fix python check problem with same name python files.

* Mon Sep 25 2023 cunshunxia <cunshunxia@tencent.com> - 4.5-1
- upgrade to 4.5
- fix missing check with funcs in class.

* Fri Sep 22 2023 cunshunxia <cunshunxia@tencent.com> - 4.4-1
- upgrade to 4.4
- funcs started with "_" is recognized as internal funcs
- internal funcs changed or removed defined as 'medium' level
- keep python tmp files when log level is DEBUG
- fix grep warning

* Thu Sep 21 2023 cunshunxia <cunshunxia@tencent.com> - 4.3-1
- upgrade to 4.3
- fix pkgname error when use abicheck --d1/d2
- check removed files in new rpm and make it uncompatible.

* Tue Sep 12 2023 cunshunxia <cunshunxia@tencent.com> - 4.2-1
- upgrade to 4.2
- add severity for different python args compatibility

* Tue Sep 12 2023 cunshunxia <cunshunxia@tencent.com> - 4.0-2
- upgrade to 4.1
- support python optional args check.

* Wed Sep 06 2023 cunshunxia <cunshunxia@tencent.com> - 4.0-1
- upgrade to 4.0
- support python api check.

* Tue Aug 29 2023 cunshunxia <cunshunxia@tencent.com> - 3.6-1
- upgrade to 3.6
- use regular expression to solve most special lib name.

* Tue Aug 15 2023 cunshunxia <cunshunxia@tencent.com> - 3.5-1
- upgrade to 3.5
- fix soname check failed
- output the result at end.
- add special name list

* Tue Aug 15 2023 cunshunxia <cunshunxia@tencent.com> - 3.4-1
- upgrade to 3.4
- check library with soname
- skip and log if abi-dumper failed
- add pkg_name to summary.log

* Thu Aug 03 2023 cunshunxia <cunshunxia@tencent.com> - 3.3-1
- upgrade to 3.3.
- add --version option
- add warning log level
- hightlight the version changes of libraries.

* Wed Aug 02 2023 cunshunxia <cunshunxia@tencent.com> - 3.2-1
- upgrade to 3.2.
- skip src pkg in abi_check3.

* Tue Jul 25 2023 cunshunxia <cunshunxia@tencent.com> - 3.1-1
- upgrade to 3.1.
- fix wrong debuginfo name when check with dirs.
- skip packages if check failed.

* Mon Jul 24 2023 cunshunxia <cunshunxia@tencent.com> - 3.0-1
- upgrade to 3.0.

* Thu Jul 20 2023 cunshunxia <cunshunxia@tencent.com> - 2.8-1
- mute logs in details, enable --verbose if needed.

* Tue Jul 18 2023 cunshunxia <cunshunxia@tencent.com> - 2.7-1
- support configure special library names in special_name_list

* Mon Jul 17 2023 cunshunxia <cunshunxia@tencent.com> - 2.6-1
- Add support for verbose mode.
- Support check with http urls.

* Thu Jul 13 2023 cunshunxia <cunshunxia@tencent.com> - 2.5-1
- fix abidump failed with dot in dirname.

* Tue Jul 11 2023 cunshunxia <cunshunxia@tencent.com> - 2.3-1
- support abi check with debuginfo.

* Tue Jun 27 2023 cunshunxia <cunshunxia@tencent.com> - 2.2-1
- fix header files of bluez not be include in right order.

* Tue Jun 27 2023 cunshunxia <cunshunxia@tencent.com> - 2.0-1
- support storage of rpm data.

* Mon Jun 19 2023 cunshunxia <cunshunxia@tencent.com> - 1.0-1
- initial build
